#include<htc.h>
#define _XTAL_FREQ 20e6
#define en RD7
#define rs RD6
#define rw RD5

             //Function for sending values to the command register of LCD
void lcdcmd(unsigned char value)  
{
PORTB=value;
rs= 0;           //register select-rs 
rw = 0;      //read-write-rd
en = 1;    //enable-e
__delay_ms(500);
en=0;       //enable-e
__delay_ms(500);

}
             //Function for sending values to the data register of LCD
void display(unsigned char value)  
{
PORTB=value;
rs= 1;       //register select-rs 
rw= 0;       //read-write-rd
en= 1;       //enable-e
__delay_ms(500);
en=0;        //enable-e
__delay_ms(500);

}
             //function to initialize the registers and pins of LCD
             //always use with every lcd of hitachi
void lcdint(void)         
{
TRISB=0x00;    //Port 1 is used as output port             
TRISD5=0;
TRISD6=0;
TRISD7=0; 
     __delay_ms(1500);
     display(0x30);
     __delay_ms(4500);
     display(0x30);
     __delay_ms(300);
     display(0x30);
     __delay_ms(650);
lcdcmd(0x38);
__delay_ms(50);
lcdcmd(0x0F);
__delay_ms(50);
lcdcmd(0x06);
__delay_ms(50);
lcdcmd(0x01);
__delay_ms(50);
lcdcmd(0x80);
__delay_ms(50);
lcdcmd(0x01);
}


void main(){
TRISC7 = 1;
unsigned char RData;
TRISB  =0x00;  //Port-B as Output
TXSTA=0x04;   //Setting USART Asyncronous Mode
RCSTA=0x90;   //Configuring Rx pin 
SPBRG=0x81;   //Setting baud rate 9600bps
lcdint();

while(1){
while(RCIF==0);  //Poll if RCIF is Empty
RData=RCREG;
display(RData);
}
}
